#define _GNU_SOURCE

#include <stdio.h>
#include <string.h>
#include <getopt.h>
#include "observ_table.h"
#include "ska_survey.h"
#include "my_stdio.h"



char *help_text[] ={
//	"  -d\t\t\t- set data directoy (def.: "DATA_DIR")",
	"  -f\t\t\t- set observation file (def.: "OBSERV_FILE")",
	"  --help\t\t- this help !!!.",
	""
};


void usage(char *program_name)
{
	fprintf(stderr,
		"Usage: \t%s [-hf][--help]\n",
		program_name);
}


void help()
{
	int i=0;

	while((char) *help_text[i] != 0)
		fprintf(stderr,"%s\n",help_text[i++]);
	fprintf(stderr,"\n");
}



int main(int argc, char **argv)
{
	struct observ *obs, *obsp;
	char *data_dir=DATA_DIR;
	char *observ_file = OBSERV_FILE;
	char *program_name;

	char *cp;
	int op;
	static struct option  const  longopts[] =
	{
		{"help", 0, 0, 101},
		{0,  0,  0,  0}
	};

	/* who is my name? */
	if ((cp = strrchr(argv[0], '/')) != NULL) program_name  = cp + 1;
	else program_name  = argv[0];
  
	verbose_flag = 0;
	opterr =  0;
	while  ((op = getopt_long(argc, argv, "v:f:",longopts, 0)) != EOF)
		switch( op ){
		case 'v':
			verbose_flag = (verbose_flag << 1) | 1;
			break;
		case 101:
			usage(program_name);
			help();
			exit(-1);
			break;
		case 'd':
			data_dir = optarg;
			break;
		case 'f':
			observ_file = optarg;
			break;
		default:
			usage(program_name);
			exit(-1);
		}
	


	obs = obsp = get_observ_table(observ_file);
	
	printf("#M StartFre StopFreq RBW  Swee R S\n");
	while( obsp->next != NULL){
		printf("%d %8.5f %8.5f %4d %4d %2d %c\n", 
		       obsp->mode, obsp->start_freq, obsp->stop_freq,
		       obsp->RBW, obsp->sweep, obsp->repetitions, 
		       obsp->switchs);
		obsp = obsp->next;
	}
	free_observ_table(obs);

	return 0;
}

